#include "timer.h"

unsigned int decodeTempo(const MidiEvent& tempoChange) {
	/*	Reads the Tempo from the Event, Unit is quarter notes (=beats) per microsecond */
	int len = tempoChange[2];//Wie viele Bytes hat das Tempo?
	
	unsigned char tNum[4] = {0x00, 0x00, 0x00, 0x00};
	unsigned int *tInt = (unsigned int*) tNum;
	
	for(int i = 0;i < len;i++) tNum[len-1-i] = tempoChange[3+i];
	
	#ifdef DEBUG
	std::cout << "[INFO] Tempo: " << std::dec << *tInt << " Quarter Notes per Microsecond " << std::endl;
	#endif
	
	return *tInt;
}

double mtempoToSpeed(unsigned int mSecQuarter, int ticksPerQuarter) {
	/* Converts a Midi Tempo from Quarter Notes per microsecond to the allegro-needed seconds per tick
		
		Helpful Sites on this topic are
		http://www.recordingblogs.com/sa/Wiki/topic/MIDI-Set-Tempo-meta-message
		http://www.recordingblogs.com/sa/Wiki/topic/Time-division-of-a-MIDI-file
	*/
	int tempo2 = mSecQuarter / 1000;
	double tempo3 = (double) tempo2 / 1000.0;
	double sekProTick = tempo3 / (double) ticksPerQuarter ;
	
	return sekProTick;
}
