#ifndef TRACK_H
#define TRACK_H
#include "base.h"

class Track {
	private:
		static std::vector<MidiEventListener*> listeners;
		
		int myID = 0;
		MidiFile *file = nullptr;
		
		int curEvent = 0;
		bool ended = false;
		
		MidiEventList& events() {
			return (*file)[myID];
		}
	public:
		Track(MidiFile *tfile, int num) : myID(num), file(tfile) {
			
		}
		
		static void addListener(MidiEventListener *lis) {
			for(int i = 0;i < listeners.size();i++) if(listeners[i] == lis) return;
			
			listeners.push_back(lis);
		}
		void update(int);
		
		void reset() {
			ended = false;
			curEvent = 0;
		}
		
		unsigned int getLength() {
			return events()[events().getSize()-1].tick;
		}
 		
		void end() {
			ended = true;
		}
		
		bool isFinished() {
			return ended;
		}
};

#endif
